local S     = {}

local ti, tc, sf = table.insert, table.concat, string.format

function S.string(val)
    return sf('%q', val)
end

function S.number(val)
    if math.floor(val) == val then return tostring(val) end
    
    local val = sf('%e', val):gsub(',', '.')
    return val
end

function S.table(val)
    local aux = { '{', }
    
    for k, v in pairs(val) do
        if type(v) ~= 'function' then
            ti(aux, sf('\t[%s] = %s,', S(k), S(v) ) )
        end
    end
    
    ti(aux, '}')
    
    return tc(aux, '\n')
end

S['function'] = function(val)
    return 'nil'
end

setmetatable(S, {
    __index = function()
        return tostring 
    end,
    
    __call  = function(tbl, val)
        return S[ type(val) ]( val )
    end
})

return S
